--Script created by FecoMatter

----Edit these variables----

local moreStairs = false
local v1Generation = false
local saveCharts = true
local modName = 'Randomizer Script' --'ModNameHere'
local printPlaybacks = false --If true, prints playback notes for testing purposes, or just to look neat

----Randomizer settings----
local randomizeDirections = true
local randomizeNoteTypes = true

--If you're looking to add custom notes, PLEASE CHECK THE README.txt FILE!!
--You do not need to touch the script to add custom notes

----Stop editing stuff unless you're screwing with code----

local curOpponentNote
local curPlayerNote

local prevOpponentNote
local prevPlayerNote

local curOpponentNote2
local curPlayerNote2

local curOpponentNote3
local curPlayerNote3

local curOpponentMissNote
local curPlayerMissNote

local curNoteTypeOpponent
local curNoteTypePlayer

local saveFile
local typesFile
local readingFromChart = false
local readingFromNoteTypes = false
local curNote
local curNoteType

local noteDiffOpponent = 0
local noteDiffPlayer = 0

local noteTypes = {'', 'Alt Animation', 'Hey!', 'Hurt Note', 'GF Sing', 'No Animation'} --Base game notes

function onCreate()
    if modName == nil then --Grab file for chart playbacks
        typesFile = io.open('mods/data/playbackCharts/' .. songName .. '-noteTypes.txt', 'r')
    else
        typesFile = io.open('mods/' .. modName .. '/data/playbackCharts/' .. songName .. '-noteTypes.txt', 'r')
    end
    if typesFile ~= nil then --If the file exists
        readingFromNoteTypes = true
        curNote = typesFile:read('*l')
    end
    if modName == nil then --Grab file for chart playbacks
        saveFile = io.open('mods/data/playbackCharts/' .. songName .. '.txt', 'r')
    else
        saveFile = io.open('mods/' .. modName .. '/data/playbackCharts/' .. songName .. '.txt', 'r')
    end
    if typesFile == nil and randomizeNoteTypes == true and saveCharts == true then
        if modName == nil then
            typesFile = io.open('mods/data/savedCharts/' .. songName .. '-noteTypes.txt', 'w')
        else
            typesFile = io.open('mods/' .. modName .. '/data/savedCharts/' .. songName .. '-noteTypes.txt', 'w')
        end
        typesFile:write('This is a save for the noteTypes in a random chart generated in Psych Engine, if you want to play it back, please put it in data/playbackCharts and go to the song with the same name!')
    end
    if saveFile ~= nil then --If the file exists
        readingFromChart = true
        curNote = saveFile:read('*l')
        return
    end
    if modName == nil and saveCharts == true and randomizeDirections == true then --Open file for saving charts
        saveFile = io.open('mods/data/savedCharts/' .. songName .. '.txt', 'w')
    elseif saveCharts == true and randomizeDirections == true then
        saveFile = io.open('mods/' .. modName .. '/data/savedCharts/' .. songName .. '.txt', 'w')
    end
    saveFile:write('This is a save for the random note generator for Psych Engine, if you want to play it back, please put it in data/playbackCharts and go to the song with the same name!')

end

function onSpawnNote(id, noteData, noteType, isSustainNote)
    if readingFromChart ~= true and readingFromNoteTypes ~= true then --If not currently playing back a chart
        if not getPropertyFromGroup('notes', id, 'mustPress') and not isSustainNote then --If is an opponent note and not a sustain
            if getPropertyFromGroup('notes', id, 'ignoreNote') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'ignoreNote') and getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true then --if is a miss note
                doOpponentMissNote(id)
                return
            end
            doOpponentNote(id)
        elseif not isSustainNote then --If is player note and not a sustain
            if getPropertyFromGroup('notes', id, 'ignoreNote') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'ignoreNote') and getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true then --If is a miss note
                doPlayerMissNote(id)
                return
            end
            doPlayerNote(id)
        else
            doSussyNotes(id)
        end
    elseif readingFromChart == true then
        curNote = saveFile:read('*l') --Read the next line of the file and set that to the current noteData

        if curNote ~= nil then
            if printPlaybacks == true then
                debugPrint(curNote)
            end
            setPropertyFromGroup('notes', id, 'noteData', curNote)
        else --If for whatever reason the playback ends in the middle of the chart
            readingFromChart = false
        end

        if readingFromNoteTypes == true then
            curNoteType = typesFile:read('*l')

            if curNoteType ~= nil then
                if printPlaybacks == true then
                    debugPrint(curNoteType)
                end
                setPropertyFromGroup('notes', id, 'noteType', curNoteType)
            else --If for whatever reason the playback ends in the middle of the chart
                readingFromNoteTypes = false
            end
        end

        doTextures(id, curNoteType)
    elseif readingFromNoteTypes == true then
        curNoteType = typesFile:read('*l')

        if curNoteType ~= nil then
            if printPlaybacks == true then
                debugPrint(curNoteType)
            end
            setPropertyFromGroup('notes', id, 'noteType', curNoteType)
        else --If for whatever reason the playback ends in the middle of the chart
            readingFromNoteTypes = false
        end

        doTextures(id, curNoteType)
    end
end

function doOpponentNote(id)
    if randomizeDirections == true then
        curOpponentNote = getRandomInt(1, 4) - 1 --Set curOpponentNote to a random note

        if v1Generation ~= true then

            if curOpponentNote == prevOpponentNote or curOpponentNote == curOpponentNote2 or curOpponentNote == curOpponentNote3 or curOpponentNote == curOpponentMissNote then --If curOpponentNote lines up with any of the other values

                local isLeft = getRandomBool() --Does the note move left or right?
                local stop = false --Variable to stop the for do function

                for i = 1, 3 do
                    if stop == false then
                        local hippo

                        if isLeft == true then
                            hippo = curOpponentNote - i --Moves the note left by i
                        else
                            hippo = curOpponentNote + i --Moves the note right by i
                        end

                        if hippo > 3 then hippo = hippo - 4 end --Set note back in range
                        if hippo < 0 then hippo = hippo + 4 end --Set note back in range

                        if hippo ~= prevOpponentNote and hippo ~= curOpponentNote2 and hippo ~= curOpponentNote3 and hippo ~= curOpponentMissNote then --If the note doesn't line up with any of the other variables
                            curOpponentNote = hippo
                            stop = getRandomBool() --1 in 2 chance of stopping
                        end
                    end
                end
            end

            curOpponentNote3 = curOpponentNote2
            curOpponentNote2 = prevOpponentNote

        else

            if curOpponentNote == prevOpponentNote then

                curOpponentNote = curOpponentNote + getRandomInt(1, 3) --Make a random note that isn't a jack
                if curOpponentNote > 3 then --Set note back in range
                    curOpponentNote = curOpponentNote - 4
                end

            end

            if curOpponentNote == curOpponentMissNote then --If there's a miss note right before the note
                curOpponentNote = curOpponentNote + getRandomInt(1, 3) --Make the note not in the same spot as the hurt note
                if curOpponentNote > 3 then --Set note back in range
                    curOpponentNote = curOpponentNote - 4
                end
                if curOpponentNote == prevOpponentNote then
                    local stop = false
                    for i = 1, 3 do --Change the note position and don't change it back into the hurt note
                        if stop ~= true then
                            local hippo = curOpponentNote + i
                            if hippo > 3 then hippo = hippo - 4 end
                            if hippo ~= curOpponentMissNote then
                                setPropertyFromGroup('notes', id, 'noteData', hippo)
                                stop = true
                            end
                        end
                    end
                end
            end

        end

        prevOpponentNote = curOpponentNote

        setPropertyFromGroup('notes', id, 'noteData', curOpponentNote) --Set noteData
        if moreStairs == true then
            runTimer('opponentNote', 0.2) --Timer to remove curOpponentNote2
        else
            if 0.3 - noteDiffOpponent * 2.3 > 0 then
                runTimer('opponentNote', 0.3 - noteDiffOpponent * 2.3)
            else
                runTimer('opponentNote', 0.01)
            end
            noteDiffOpponent = 0
        end
        runTimer('opponentNoteBUTFAST', 0.05) --Timer to remove curOpponentNote3

        if saveCharts == true then
            saveFile:write('\n' .. curOpponentNote) --Save the note value in the txt file
        end
    end

    if randomizeNoteTypes == true then
        curNoteTypeOpponent = getRandomInt(1, #noteTypes)

        setPropertyFromGroup('notes', id, 'noteType', noteTypes[curNoteTypeOpponent])

        if saveCharts == true then
            typesFile:write('\n' .. noteTypes[curNoteTypeOpponent])
        end
    end

    doTextures(id, noteTypes[curNoteTypeOpponent])

end

function doPlayerNote(id)
    if randomizeDirections == true then
        curPlayerNote = getRandomInt(1, 4) - 1

        if v1Generation ~= true then

            if curPlayerNote == prevPlayerNote or curPlayerNote == curPlayerNote2 or curPlayerNote == curPlayerNote3 or curPlayerNote == curPlayerMissNote then --If curPlayerNote lines up with any of the other values

                local isLeft = getRandomBool() --Does the note move left or right?
                local stop = false --Variable to stop the for do function

                for i = 1, 3 do
                    if stop == false then
                        local hippo

                        if isLeft == true then
                            hippo = curPlayerNote - i --Moves the note left by i
                        else
                            hippo = curPlayerNote + i --Moves the note right by i
                        end

                        if hippo > 3 then hippo = hippo - 4 end --Set note back in range
                        if hippo < 0 then hippo = hippo + 4 end --Set note back in range

                        if hippo ~= prevPlayerNote and hippo ~= curPlayerNote2 and hippo ~= curPlayerNote3 and hippo ~= curPlayerMissNote then --If the note doesn't line up with any of the other variables
                            curPlayerNote = hippo
                            stop = getRandomBool() --1 in 2 chance of stopping
                        end
                    end
                end
            end

            curPlayerNote3 = curPlayerNote2
            curPlayerNote2 = prevPlayerNote

        else

            if curPlayerNote == prevPlayerNote then

                curPlayerNote = curPlayerNote + getRandomInt(1, 3) --Make a random note that isn't a jack
                if curPlayerNote > 3 then --Set note back in range
                    curPlayerNote = curPlayerNote - 4
                end

            end

            if curPlayerNote == curPlayerMissNote then --If there's a miss note right before the note
                curPlayerNote = curPlayerNote + getRandomInt(1, 3) --Make the note not in the same spot as the hurt note
                if curPlayerNote > 3 then --Set note back in range
                    curPlayerNote = curPlayerNote - 4
                end
                if curPlayerNote == prevPlayerNote then
                    local stop = false
                    for i = 1, 3 do --Change the note position and don't change it back into the hurt note
                        if stop ~= true then
                            local hippo = curPlayerNote + i
                            if hippo > 3 then hippo = hippo - 4 end
                            if hippo ~= curPlayerMissNote then
                                setPropertyFromGroup('notes', id, 'noteData', hippo)
                                stop = true
                            end
                        end
                    end
                end
            end

        end

        prevPlayerNote = curPlayerNote

        setPropertyFromGroup('notes', id, 'noteData', curPlayerNote) --Set noteData
        if moreStairs == true then
            runTimer('playerNote', 0.2) --Timer to remove curPlayerNote2
        else
            if 0.3 - noteDiffPlayer * 2.3 > 0 then
                runTimer('playerNote', 0.3 - noteDiffPlayer * 2.3)
            else
                runTimer('playerNote', 0.01)
            end
            noteDiffPlayer = 0
        end
        runTimer('playerNoteBUTFAST', 0.05) --Timer to remove curPlayerNote3

        if saveCharts == true then
            saveFile:write('\n' .. curPlayerNote) --Save the note value in the text file
        end
    end

    if randomizeNoteTypes == true then
        curNoteTypePlayer = getRandomInt(1, #noteTypes)

        setPropertyFromGroup('notes', id, 'noteType', noteTypes[curNoteTypePlayer])

        if saveCharts == true then
            typesFile:write('\n' .. noteTypes[curNoteTypePlayer])
        end
    end

    doTextures(id, noteTypes[curNoteTypePlayer])

end

function doOpponentMissNote(id)

    --These work practically the same, just with the curMissNote note value instead of the curNoteValue

    curOpponentMissNote = getRandomInt(1, 4) - 1

    if v1Generation ~= true then

        if curOpponentMissNote == prevOpponentNote or curOpponentMissNote == curOpponentNote2 or curOpponentMissNote == curOpponentNote3 or curOpponentMissNote == curOpponentNote then

            local isLeft = getRandomBool()
            local stop = false

            for i = 1, 3 do
                if stop == false then
                    local hippo

                    if isLeft == true then
                        hippo = curOpponentMissNote - i
                    else
                        hippo = curOpponentMissNote + i
                    end

                    if hippo > 3 then hippo = hippo - 4 end
                    if hippo < 0 then hippo = hippo + 4 end

                    if hippo ~= prevOpponentNote and hippo ~= curOpponentNote2 and hippo ~= curOpponentNote3 and hippo ~= curOpponentNote then
                        curOpponentMissNote = hippo
                        stop = getRandomBool()
                    end
                end
            end
        end

    else

        if curOpponentMissNote == curOpponentNote then
            curOpponentMissNote = curOpponentMissNote + getRandomInt(1, 3) --Stop the hurt note from being right after the current note
            if curOpponentMissNote > 3 then --Set note back in range
                curOpponentMissNote = curOpponentMissNote - 4
            end
        end

    end

    setPropertyFromGroup('notes', id, 'noteData', curOpponentMissNote)
    runTimer('opponentMissNote', 0.2) --Timer to remove curMissNote

    if saveCharts == true then
        saveFile:write('\n' .. curOpponentMissNote)
    end

    doTextures(id)

end

function doPlayerMissNote(id)

    --These work practically the same, just with the curMissNote note value instead of the curNoteValue

    curPlayerMissNote = getRandomInt(1, 4) - 1

    if v1Generation ~= true then

        if curPlayerMissNote == prevPlayerNote or curPlayerMissNote == curPlayerNote2 or curPlayerMissNote == curPlayerNote3 or curPlayerMissNote == curPlayerNote then

            local isLeft = getRandomBool()
            local stop = false

            for i = 1, 3 do
                if stop == false then
                    local hippo

                    if isLeft == true then
                        hippo = curPlayerMissNote - i
                    else
                        hippo = curPlayerMissNote + i
                    end

                    if hippo > 3 then hippo = hippo - 4 end
                    if hippo < 0 then hippo = hippo + 4 end

                    if hippo ~= prevPlayerNote and hippo ~= curPlayerNote2 and hippo ~= curPlayerNote3 and hippo ~= curPlayerNote then
                        curPlayerMissNote = hippo
                        stop = getRandomBool()
                    end
                end
            end
        end

    else

        if curPlayerMissNote == curPlayerNote then
            curPlayerMissNote = curPlayerMissNote + getRandomInt(1, 3) --Stop the hurt note from being right after the current note
            if curPlayerMissNote > 3 then --Set note back in range
                curPlayerMissNote = curPlayerMissNote - 4
            end
        end

    end

    setPropertyFromGroup('notes', id, 'noteData', curPlayerMissNote)
    runTimer('playerMissNote', 0.2) --Timer to remove curMissNote

    if saveCharts == true then
        saveFile:write('\n' .. curPlayerMissNote)
    end

    doTextures(id)

end

function doSussyNotes(id)
    if not getPropertyFromGroup('notes', id, 'mustPress') then --If is opponent note
        if getPropertyFromGroup('notes', id, 'ignoreNote') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'ignoreNote') and getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true then --If is miss note
            setPropertyFromGroup('notes', id, 'noteData', curOpponentMissNote) --Set value to the same as the last hurt note
            if moreStairs == true then
                runTimer('opponentMissNote', 0.2)
            end

            if saveCharts == true then
                saveFile:write('\n' .. curOpponentMissNote) --Save the value
            end
        else --If is good note
            if randomizeDirections == true then
                setPropertyFromGroup('notes', id, 'noteData', curOpponentNote) --Set value to the same as the last note
                if moreStairs == true then
                    runTimer('opponentNote', 0.2)
                end

                if saveCharts == true then
                    saveFile:write('\n' .. curOpponentNote) --Save the value
                end
            end

            if randomizeNoteTypes == true then

                setPropertyFromGroup('notes', id, 'noteType', noteTypes[curNoteTypeOpponent])
                doTextures(id, noteTypes[curNoteTypeOpponent])

                if saveCharts == true then
                    typesFile:write('\n' .. noteTypes[curNoteTypeOpponent])
                end
            end
        end
    else --If is player note
        if getPropertyFromGroup('notes', id, 'ignoreNote') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true or getPropertyFromGroup('notes', id, 'ignoreNote') and getPropertyFromGroup('notes', id, 'hitCausesMiss') and randomizeNoteTypes ~= true then --If is miss note
            setPropertyFromGroup('notes', id, 'noteData', curPlayerMissNote) --Set value to the same as the last hurt note
            if moreStairs == true then
                runTimer('playerMissNote', 0.2)
            end

            if saveCharts == true then
                saveFile:write('\n' .. curPlayerMissNote) --Save the value
            end
        else --If is good note
            if randomizeDirections == true then
                setPropertyFromGroup('notes', id, 'noteData', curPlayerNote) --Set value to the same as the last note
                if moreStairs == true then
                    runTimer('opponentNote', 0.2)
                end

                if saveCharts == true then
                    saveFile:write('\n' .. curPlayerNote) --Save the value
                end
            end

            if randomizeNoteTypes == true then
        
                setPropertyFromGroup('notes', id, 'noteType', noteTypes[curNoteTypePlayer])
                doTextures(id, noteTypes[curNoteTypePlayer])
        
                if saveCharts == true then
                    typesFile:write('\n' .. noteTypes[curNoteTypePlayer])
                end
            end
        end
    end
end

function doTextures(id, noteType)
    if noteType == '' or noteType == 'No Animation' or noteType == 'GF Sing' or noteType == 'Alt Animation' or noteType == 'Hey!' then
        setPropertyFromGroup('notes', id, 'texture', 'NOTE_assets')
    elseif noteType == 'Hurt Note' then
        setPropertyFromGroup('notes', id, 'texture', 'HURTNOTE_assets')
    else
        setPropertyFromGroup('notes', id, 'texture', 'notes/' .. string.upper(noteType:gsub(' ', '')) .. '_assets')
    end
end

function onUpdate(elapsed)
    if not getProperty('paused') then
        noteDiffOpponent = noteDiffOpponent + elapsed
        noteDiffPlayer = noteDiffPlayer + elapsed
    end
end

function onTimerCompleted(tag) --Remove things
    if tag == 'opponentNote' then
        curOpponentNote2 = nil
    elseif tag == 'playerNote' then
        curPlayerNote2 = nil
    elseif tag == 'opponentNoteBUTFAST' then
        curOpponentNote3 = nil
    elseif tag == 'playerNoteBUTFAST' then
        curPlayerNote3 = nil
    elseif tag == 'opponentMissNote' then
        curOpponentMissNote = nil
    elseif tag == 'playerMissNote' then
        curPlayerMissNote = nil
    end
end

function onDestroy() --Close the save file
    if saveFile ~= nil then
        saveFile:close()
    end
    if typesFile ~= nil then
        typesFile:close()
    end
end

function onGameOverConfirm(retry) --Close the save file
    if saveFile ~= nil then
        saveFile:close()
    end
    if typesFile ~= nil then
        typesFile:close()
    end
end

function onEvent(name, note, v2)
    if name == 'addNoteToList' then
        for i = 1, #noteTypes do --Check through all noteTypes
            if note == noteTypes[i] then --If the note to add is already in the list
                debugPrint('The note ' .. note .. ' already exists!')
                return
            end
        end

        noteTypes[#noteTypes + 1] = note --Add note to list
    elseif name == 'removeNoteFromList' then
        local somethingHappened = false --Variable to check if anything was removed
        for i = 1, #noteTypes do --Check through all noteTypes
            if note == noteTypes[i] then --Find the note to remove, if it exists
                for ii = i, #noteTypes - 1 do --Do for all notes including the current note
                    noteTypes[ii] = noteTypes[ii + 1] --Move all notes back to make up for the empty spot
                end
                somethingHappened = true --Something did indeed happen
                noteTypes[#noteTypes] = nil --Remove the duplicate last note
            end
        end
        if somethingHappened == false then --If nothing happened
            debugPrint('The note ' .. note .. ' does not exist!')
        end
    end
end